#include <iostream>

/*
  Utilisation des pointeurs ou des references pour intervertir deux variables
*/



void echange_0(int a, int b)
/*
  Cet exemple ne marche pas : les variables a et b sont locales
  a la fonction et n'existent plus a la fin de son execution
*/
{
  int sauv = a;
  a = b;
  b = sauv;
}


void echange_1(int *a, int *b)
/*
  Solution "a la C" : on utilise des pointeurs
 */
{
  int sauv = *a;
  *a = *b;
  *b = sauv;
}


void echange_2(int &a, int &b)
/*
  Solution "a la C++" : on utilise des references, la syntaxe
  est plus naturelle (moins d'utilisation de * et &)
 */
{
  int sauv = a;
  a = b;
  b = sauv;
}



int main(void)
{
  int a = 1, b = 2;

  std::cout << "Au debut : a = " << a << ", b = " << b << "\n";
  echange_0(a,b);  // echange_0 ne marche pas
  std::cout << "Apres appel de echange_0 : a = " << a << ", b = " << b << "\n" << "\n";
  
  std::cout << "Au debut : a = " << a << ", b = " << b << "\n";
  echange_1(&a,&b); // echange_1 s'appelle avec les adresses de a et b
  std::cout << "Apres appel de echange_1 : a = " << a << ", b = " << b << "\n" << "\n";

  std::cout << "Au debut : a = " << a << ", b = " << b << "\n";
  echange_2(a,b); // echange_2 s'appelle en entrant directement les noms de a et b (pas de "&")
  std::cout << "Apres appel de echange_2 : a = " << a << ", b = " << b << "\n";

  return 0;
}
