#include "tableau.hpp"
#include <iostream>
#include <random>

const int n = 10; // Taille des tableaux consideres

int main(void)
{
  double *tab = new double[n];

  std::mt19937 gen(6311);
  remplit_tableau(tab, n, gen);
  std::cout << "Tableau rempli aleatoirement :\n";
  for (int i=0; i<n; i++)
	std::cout << "tab[" << i << "] = " << tab[i] << "\n";
  

  std::cout << "\nMaximum du tableau : " << maximum(tab, n) << "\n\n";
  

  std::cout << "On trie le tableau (tri par insertion) :\n";
  tri_insertion(tab, n);
  for (int i=0; i<n; i++)
	std::cout << "tab[" << i << "] = " << tab[i] << "\n";


  gen.seed(6311);// On reinitialise le generateur avec la meme graine : on va donc retrouver les memes nombres aleatoires
  remplit_tableau(tab, n, gen);
  std::cout << "\nOn reprend notre tableau non trié... :\n";
  for (int i=0; i<n; i++)
	std::cout << "tab[" << i << "] = " << tab[i] << "\n";
  std::cout << "... que l'on trie aussi (tri rapide) :\n";
  tri_rapide(tab, n);
  for (int i=0; i<n; i++)
	std::cout << "tab[" << i << "] = " << tab[i] << "\n";
  

  
  return 0;
  
}
