#include "tableau.hpp"
#include <iostream>

/*
  Comparaison de l'efficacite de l'algorithme de tri par insertion
  et de l'algorithme de tri rapide.

  On peut aussi utiliser la commande unix "time" pour mesurer le temps
  d'execution d'un programme (lancer dans le terminal "time ./mon_programme").
 */


const int n = 50000;
/*
  On prend un "gros" tableau. Le tri par insertion a une complexite en n^2
  alors que le tri rapide a une complexite en nlog(n). Le tri par insertion
  est donc beaucoup plus lent.
*/


int main(void)
{
  double *tab = new double[n];
  
  std::mt19937 gen(673);
  remplit_tableau(tab, n, gen);
  std::cout << "\nOn trie le tableau avec le tri rapide (qui est... rapide).\n";
  tri_rapide(tab, n);
  std::cout << "Fait.\n\n";
  
  
  gen.seed(673);
  // On reinitialise le generateur avec la meme graine pour avoir le meme tableau
  remplit_tableau(tab, n, gen);
  std::cout << "On trie le (meme) tableau avec le tri par insertion (qui est beaucoup plus lent).\n";
  tri_insertion(tab, n);
  std::cout << "Fait.\n\n";
  
  return 0;
  
}
