/*
  Fichier en-tete contenant les declarations des
  fonctions liees aux vecteurs.
*/


#ifndef _VECTEUR_HPP_
#define _VECTEUR_HPP_
/*
  Les deux lignes precedentes permettent de s'assurer que le fichier
  en-tete n'a pas ete inclus plusieurs fois. Si le fichier etait inclus
  plusieurs fois, la meme fonction aurait plusieurs declaration ce qui
  causerait une erreur.

  Ci dessus, on peut remplacer "_TABLEAU_HPP_" par n'importe quelle
  chaine de caractere suffisament particuliere pour ne pas etre utilisee
  ailleurs.
*/

#include <cmath>
#include <iostream>
#include <random>
#include <vector>


// Renvoie le maximum du tableau tab de taille n
double maximum(std::vector<double> const &);

//Remplit le tableau tab (de taille n) avec des nombres aleatoires
void remplit_vecteur(std::vector<double>&, std::mt19937 &gen);

//Affiche un histogramme à 10 classes du tableau
void histogramme(std::vector<double> const &);

/* Algorithmes de tri*/
// Tri par insertion
void tri_insertion(std::vector<double> &);

// Tri rapide (avec une fonction auxilliaire)
void tri_rapide(std::vector<double>&);
void tri_rapide_aux(std::vector<double>&, int debut, int fin);


#endif /* _TABLEAU_HPP_ */
